--[[-------------------------------------------------------------------------
  *
  * RaidIcons module for PerfectRaid addon.
  *
  * Written by: Panoramix
  * Version: 1.0
  *   
---------------------------------------------------------------------------]]

local RaidIcons = PerfectRaid:NewModule("PerfectRaid-RaidIcons")
local L = PerfectRaidLocals
local utils, frames

function RaidIcons:Initialize()
	
	frames = PerfectRaid.frames
	utils = PerfectRaid.utils
	
	self:RegisterEvent("RAID_TARGET_UPDATE", "UpdateAllUnits");		
	self:RegisterEvent("RAID_ROSTER_UPDATE", "UpdateAllUnits");
end

function RaidIcons:UpdateAllUnits( )

	for index = 1, GetNumRaidMembers() do
		local raidunit = "raid" .. index;
		local raidicon = GetRaidTargetIndex( raidunit );
		if ( raidicon and frames and frames[raidunit] ) then
			for frame in pairs( frames[raidunit] ) do
				-- create indicator and texture
				if ( not frame.raidicon ) then 
					frame.indicator = CreateFrame( "Frame", nil, frame.leftbox );
					frame.indicator:SetHeight( frame:GetHeight() );
					frame.indicator:SetWidth( frame:GetHeight( ) );										
					frame.indicator:SetFrameLevel( frame.leftbox:GetFrameLevel()+1 );
									
					frame.raidicon = frame.indicator:CreateTexture( nil, "OVERLAY" );
					frame.raidicon:SetAllPoints();
					frame.raidicon:SetTexture( "Interface\\TargetingFrame\\UI-RaidTargetingIcons" );					
				end
				
				-- resize the texture and show it
				frame.indicator:ClearAllPoints();
				frame.indicator:SetPoint( "RIGHT", -3-frame.name:GetWidth(), 0 );
				SetRaidTargetIconTexture( frame.raidicon, raidicon );
				frame.raidicon:Show();			
			end				
		end
		
		-- unit doesn't have raidtarget icon, hide it
		if ( not raidicon and frames and frames[raidunit] ) then
			for frame in pairs( frames[raidunit] ) do
				if ( frame.raidicon ) then
					frame.raidicon:Hide();
				end
			end
		end
	end	
end



